> For the complete documentation index, see [llms.txt](https://docs.cheqd.io/product/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cheqd.io/product/sdk/veramo/dids/query-did.md).

# Querying a DID

Follow these instructions to query a DID from cheqd ledger.

> ⚠️ **Before you begin...**
>
> Make sure you've correctly [configured the cheqd plugin's agent settings](/product/sdk/veramo/setup.md) for Veramo CLI

## Instructions

### 1. Invoke Veramo CLI's DID resolver function

Use `veramo did resolve <did>` to resolve a DID. For example:

```bash
veramo did resolve did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC
```

*TIp*: If you have followed along the process of creating a *did*. You can put your *did* instead.

```bash
veramo did resolve did:cheqd:testnet:<your_did_>
```

### 2. Inspect DID/DIDDoc output

The output should look like the following:

```json
{
  "didResolutionMetadata": {
    "contentType": "application/did+json",
    "retrieved": "2022-07-28T15:05:06Z",
    "did": {
      "didString": "did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC",
      "methodSpecificId": "PdMMR9Jb4vgKkGboB7NFLC",
      "method": "cheqd"
    }
  },
  "didDocument": {
    "id": "did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC",
    "verificationMethod": [
      {
        "id": "did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC#key1",
        "type": "JsonWebKey2020"
        "controller": "did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC",
        "publicKeyJwk": {
          "crv": "Ed25519",
          "kty": "OKP",
          "x": "jaa70K9yy4Tw-YEsA2T4F10jsQuFdpVJN9LLhjmOUGw"
        },
    "authentication": [
      "did:cheqd:mainnet:PdMMR9Jb4vgKkGboB7NFLC#key1"
        ],
      }
    ]
  },
  "didDocumentMetadata": {
    "created": "2022-05-13T14:01:20Z",
    "versionId": "83fe6fa4-c844-438f-861a-cbd91202864f"
  }
}
```

## Next steps

DID queries are passed and handled using [the cheqd DID Resolver](/product/advanced/did-resolver.md). You can also check out the API endpoints exposed by the DID Resolver to understand how this can be fetched/consumed outside Veramo CLI.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cheqd.io/product/sdk/veramo/dids/query-did.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
